<script setup lang="ts">
import { onMounted, ref } from 'vue'
import axios from 'axios';
import { Chart as ChartJS, ArcElement, Tooltip, Legend } from 'chart.js'
import { Pie } from 'vue-chartjs'

onMounted(async () => {
    await getReport2()
})

async function getReport2() {
    try {
        const res = await axios.get('http://localhost:3000/report/report3')
        console.log(res.data)

        const labels = res.data.map((it: any) => it.INCOME)
        const data = res.data.map((it: any) => it.EXPENSES)

        const colors = generateRandomColors(labels.length)

        chartData.value = {
            labels: labels,
            datasets: [
                {
                    label: 'Expenses',
                    backgroundColor: colors,
                    data: data
                }
            ]
        }
    } catch (error) {
        console.error('Error fetching data:', error)
    }
}

ChartJS.register(ArcElement, Tooltip, Legend)

const chartData = ref({
    labels: [],
    datasets: [
        {
            label: 'Expenses',
            backgroundColor: [],
            data: []
        }
    ]
})

const chartOptions = ref({
    responsive: true,
    maintainAspectRatio: false
})

function generateRandomColors(count: number) {
    const colors = []
    for (let i = 0; i < count; i++) {
        const randomColor = "#" + Math.floor(Math.random() * 16777215).toString(16)
        colors.push(randomColor)
    }
    return colors
}
</script>

<template>
    <Pie :data="chartData" :options="chartOptions" />
</template>
